#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using HeuristicLab.Common;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Hive.Contracts.BusinessObjects {
  [StorableClass]
  [DataContract]
  [Serializable]
  public class SlaveDto : ResourceDto {
    [Storable]
    [DataMember]
    public int NrOfCores { get; set; }
    [Storable]
    [DataMember]
    public int NrOfFreeCores { get; set; }
    [Storable]
    [DataMember]
    public int? CpuSpeedPerCore { get; set; }
    [Storable]
    [DataMember]
    public int Memory { get; set; }
    [Storable]
    [DataMember]
    public int FreeMemory { get; set; }
    [Storable]
    [DataMember]
    public DateTime? Login { get; set; }
    [Storable]
    [DataMember]
    public SlaveState State { get; set; }
    [Storable]
    [DataMember]
    public CalendarState CalendarSyncStatus { get; set; }
    [Storable]
    [DataMember]
    public SlaveConfigDto Config { get; set; }
    [Storable]
    [DataMember]
    public bool IsAllowedToCalculate { get; set; }

    public override string ToString() {
      return base.ToString() + ", NrOfCores: " + NrOfCores + ", NrOfFreeCores " + NrOfFreeCores + ", Login: " + Login + ", State: " + State;
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      SlaveDto clone = (SlaveDto)base.Clone(cloner);
      clone.CalendarSyncStatus = this.CalendarSyncStatus;
      clone.Config = (SlaveConfigDto)cloner.Clone(this.Config);
      clone.CpuSpeedPerCore = this.CpuSpeedPerCore;
      clone.FreeMemory = this.FreeMemory;
      clone.Login = this.Login;
      clone.Memory = this.Memory;
      clone.NrOfCores = this.NrOfCores;
      clone.NrOfFreeCores = this.NrOfFreeCores;
      clone.State = this.State;
      clone.IsAllowedToCalculate = this.IsAllowedToCalculate;
      return clone;
    }
  }
}
