﻿using System;
using HeuristicLab.Common;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Hive.JobBase;
using System.Collections.Generic;

namespace HeuristicLab.Hive.Contracts {
  [StorableClass]
  [Serializable]
  public class MessageContainerWithCallback<CallbackParameterType> : MessageContainer {

    [Storable]
    public Action<CallbackParameterType> Callback;

    public MessageContainerWithCallback(MessageType message, Guid parentJobId, Action<CallbackParameterType> callback)
      : base(message, parentJobId) {
        this.Callback = callback;
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      MessageContainerWithJob clone = (MessageContainerWithJob)base.Clone(cloner);

      return clone;
    }
  }
}
