﻿using System;
using System.Collections.Generic;
using System.Text;
using HeuristicLab.Hive.Server.DataAccess;
using HeuristicLab.Hive.Server.LINQDataAccess;

namespace HeuristicLab.Hive.Server.Core {
  public class DaoLocator {
    
    [ThreadStatic] private static ISlaveDao clientDao;
    [ThreadStatic] private static ISlaveConfigDao clientConfigDao;
    [ThreadStatic] private static ISlaveGroupDao clientGroupDao;
    [ThreadStatic] private static IJobDao jobDao;
    [ThreadStatic] private static IPluginInfoDao pluginInfoDao;
    [ThreadStatic] private static IUptimeCalendarDao uptimeCalendarDao;

    public static ISlaveDao SlaveDao {
      get {
        if (clientDao == null)
          clientDao = new SlaveDao();
        return clientDao;
      }
    }

    public static ISlaveConfigDao SlaveConfigDao {
      get {
        if(clientConfigDao == null)
          clientConfigDao = new SlaveConfigDao();
        return clientConfigDao;
      }
    }

    public static ISlaveGroupDao SlaveGroupDao {
      get {
        if(clientGroupDao == null)
          clientGroupDao = new SlaveGroupDao();
        return clientGroupDao;
      }
    }

    public static IJobDao JobDao {
      get {
        if(jobDao == null)
          jobDao = new JobDao();
        return jobDao;
      }
    }

    public static IPluginInfoDao PluginInfoDao {
      get {
        if(pluginInfoDao == null)
          pluginInfoDao = new PluginInfoDao();
        return pluginInfoDao;
      }
    }

    public static IUptimeCalendarDao UptimeCalendarDao {
      get {
        if (uptimeCalendarDao == null)
          uptimeCalendarDao = new UptimeCalendarDao();
        return uptimeCalendarDao;
      }
    }
  }
}
